organize / cleanup
[distro-setup] / mail-setup
index 1fd8fe88afb7df413844182b86002a184b4f65a0..fdb4c219d4eb2b9154c500c93fe6d751fe962113 100755 (executable)
@@ -1,4 +1,6 @@
 #!/bin/bash
+set -x
+
 # Copyright (C) 2016 Ian Kelling
 
 # Licensed under the Apache License, Version 2.0 (the "License");
@@ -25,6 +27,13 @@ Setup exim4 / postfix / dovecot
 
 The minimal assumption we have is that /etc/mailpass exists
 
+
+I\'ve had problems with postfix on debian:
+on stretch, a startup ordering issue caused all mail to fail.
+postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
+I haven\'t gotten around to getting a non-debian exim
+setup.
+
 -h|--help  Print help and exit.
 EOF
     exit $1
@@ -38,6 +47,10 @@ if ! exim && ! postfix; then
     usage 1
 fi
 
+if [[ ! $SUDO_USER ]]; then
+    echo "$0: error: requires running as nonroot or sudo"
+fi
+u=$SUDO_USER
 
 
 ####### begin perstent password instructions ######
@@ -51,7 +64,7 @@ fi
 # apg -m 50 -x 70 -n 1 -a 1 -M CLN >$f
 # s sed -i "/^$user:/d" /p/c/filesystem/etc/exim4/passwd
 # echo "$user:$(mkpasswd -m sha-512 -s <$f)" >>/p/c/filesystem/etc/exim4/passwd
-# echo "mail.iankelling.org:$user:$(<$f)" >> /p/c/machine_specific/$user/filesystem/etc/mailpass
+# echo "mail.iankelling.org $user $(<$f)" >> /p/c/machine_specific/$user/filesystem/etc/mailpass
 # # then run this script, or part of it which uses /etc/mailpass
 
 # # dovecot password, i just need 1 as I\'m the only user
@@ -101,12 +114,17 @@ fi
 # # via the mail-setup scripts
 
 # # 2017-02 dmarc policies:
+# # host -t txt _dmarc.gmail.com
 # # yahoo: p=reject, hotmail: p=none, gmail: p=none, fastmail none for legacy reasons
-# # gmail will be changing to p=reject, which is expected to cause problems
+# # there were articles claiming gmail would be  changing
+# # to p=reject, in early 2017, which didn\'t happen. I see no sources on them. It\'s
+# # expected to cause problems
 # # with a few old mailing lists, copying theirs for now.
+#
 # echo "dmarc dns, name: _dmarc value: v=DMARC1; p=none; rua=mailto:mailauth-reports@$domain"
 
 # # 2017-02 spf policies:
+# # host -t txt lists.fedoraproject.org
 # # google ~all, hotmail -all, yahoo: ?all, fastmail ?all
 # # i include fastmail\'s settings, per their instructions,
 # # and follow their policy. In mail in a box, or similar instructions,
@@ -156,7 +174,7 @@ fi
 # New one is smtp.fastmail.com
 
 # test delivery & rewrite settings:
-#exim4 -bt ian@localhost
+#exim4 -bt iank@localhost
 
 
 postconfin() {
@@ -167,10 +185,10 @@ postconfin() {
 }
 e() { printf "%s\n" "$*"; }
 
-postmaster=ian
+postmaster=$u
 mxhost=mail.iankelling.org
 mxport=25
-forward=ian@$mxhost
+forward=$u@$mxhost
 
 # old setup. left as comment for example
 # mxhost=mail.messagingengine.com
@@ -180,7 +198,11 @@ forward=ian@$mxhost
 relayhost="[$mxhost]:$mxport" # postfix
 smarthost="$mxhost::$mxport" # exim
 
-
+# trisquel 8 = openvpn, debian stretch = openvpn-client
+vpn_ser=openvpn-client
+if [[ ! -e /lib/systemd/system/openvpn-client@.service ]]; then
+    vpn_ser=openvpn
+fi
 
 if [[ $HOSTNAME == $MAIL_HOST ]]; then
     # afaik, these will get ignored because they are routing to my own
@@ -241,7 +263,7 @@ smtp_tls_CAfile = /etc/ssl/certs/ca-certificates.crt
 inet_protocols = ipv4
 EOF
     # msg_size_limit: I ran into a log file not sending cuz of size. double from 10 to 20 meg limit
-    # inet_protocols: without this, I've had postfix try an ipv6 lookup then gives
+    # inet_protocols: without this, I\'ve had postfix try an ipv6 lookup then gives
     # up and fail forever. snippet from syslog: type=AAAA: Host not found, try again
 
 
@@ -261,18 +283,24 @@ EOF
 
 else # begin exim. has debian specific stuff for now
 
+    if ! dpkg -s openvpn &>/dev/null; then
+        apt-get -y install --purge --auto-remove openvpn
+    fi
+
     if [[ -e /p/c/filesystem ]]; then
-        /a/exe/vpn-mk-client-cert -b mail -n mail li
+        # to put the hostname in the known hosts
+        ssh -o StrictHostKeyChecking=no root@li.iankelling.org :
+        /a/exe/vpn-mk-client-cert -b mail -n mail li.iankelling.org
     fi
 
-    cat >/etc/systemd/system/mailroute.service <<'EOF'
+    cat >/etc/systemd/system/mailroute.service <<EOF
 [Unit]
-# this unit is configured to start and stop whenever openvpn-client@mail.service
+# this unit is configured to start and stop whenever $vpn_ser@mail.service
 # does
 Description=Routing for email vpn
 After=network.target
-BindsTo=openvpn-client@mail.service
-After=openvpn-client@mail.service
+BindsTo=$vpn_ser@mail.service
+After=$vpn_ser@mail.service
 
 [Service]
 Type=oneshot
@@ -281,7 +309,7 @@ ExecStop=/a/bin/distro-setup/mail-route stop
 RemainAfterExit=yes
 
 [Install]
-RequiredBy=openvpn-client@mail.service
+RequiredBy=$vpn_ser@mail.service
 EOF
 
     cat >/etc/systemd/system/offlineimapsync.timer <<'EOF'
@@ -295,13 +323,13 @@ OnCalendar=*:0/5
 WantedBy=timers.target
 EOF
 
-    cat >/etc/systemd/system/offlineimapsync.service <<'EOF'
+    cat >/etc/systemd/system/offlineimapsync.service <<EOF
 [Unit]
 Description=Offlineimap sync
 After=multi-user.target
 
 [Service]
-User=ian
+User=$u
 Type=oneshot
 ExecStart=/a/bin/log-quiet/sysd-mail-once offlineimap-sync /a/bin/distro-setup/offlineimap-sync
 EOF
@@ -325,6 +353,12 @@ EOF
 
     # most of these settings get translated into settings
     # in /etc/exim4/update-exim4.conf.conf
+    # how /etc/exim4/update-exim4.conf.conf translates into actual exim settings is
+    # documented in man update-exim4.conf, which outputs to the config that
+    # exim actually reads. except the man page is not perfect, for example,
+    # it doesn't document that it sets
+    # DCconfig_${dc_eximconfig_configtype}" "1"
+    # which is a line from update-exim4.conf, which is a relatively short bash script.
     # mailname setting sets /etc/mailname
 
     debconf-set-selections <<EOF
@@ -336,6 +370,57 @@ EOF
     mkdir -p $exim_main_dir
 
 
+
+    #### begin mail cert setup ###
+    f=/usr/local/bin/mail-cert-cron
+    cat >$f <<'EOF'
+set -eE -o pipefail
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+
+[[ $EUID == 0 ]] || exec sudo "$BASH_SOURCE" "$@"
+
+f=/a/bin/bash_unpublished/source-semi-priv
+if [[ -e $f ]]; then
+    source $f
+fi
+if [[ $HOSTNAME == $MAIL_HOST ]]; then
+    local_mx=mail.iankelling.org
+    rsync_common="rsync -ogtL --chown=root:Debian-exim --chmod=640 root@li:/etc/letsencrypt/live/$local_mx/"
+    ${rsync_common}fullchain.pem /etc/exim4/exim.crt
+    ${rsync_common}privkey.pem /etc/exim4/exim.key
+fi
+EOF
+    chmod 755 $f
+
+    cat >/etc/systemd/system/mailcert.service <<'EOF'
+[Unit]
+Description=Mail cert rsync
+After=multi-user.target
+
+[Service]
+Type=oneshot
+ExecStart=/a/bin/log-quiet/sysd-mail-once mailcert /usr/local/bin/mail-cert-cron
+EOF
+
+    cat >/etc/systemd/system/mailcert.timer <<'EOF'
+[Unit]
+Description=Run mail-cert once a day
+
+[Timer]
+OnCalendar=daily
+
+[Install]
+WantedBy=timers.target
+EOF
+    systemctl daemon-reload
+    systemctl start mailcert
+    systemctl restart mailcert.timer
+    systemctl enable mailcert.timer
+
+    ##### end mailcert setup #####
+
+
+
     if [[ $HOSTNAME == $MAIL_HOST ]]; then
 
         debconf-set-selections <<EOF
@@ -375,7 +460,7 @@ exim4-config exim4/dc_eximconfig_configtype select internet site; mail is sent a
 # This name won\'t appear on From: lines of outgoing messages if rewriting is enabled.
 
 # System mail name:
-exim4-config exim4/mailname string li.iankelling.org
+exim4-config exim4/mailname string mail.iankelling.org
 
 
 
@@ -393,7 +478,7 @@ exim4-config exim4/mailname string li.iankelling.org
 # Other destinations for which mail is accepted:
 # iank.bid is for testing
 # mail.iankelling.org is for machines i own
-exim4-config exim4/dc_other_hostnames string *.iankelling.org;iankelling.org;*iank.bid;iank.bid;*zroe.org;zroe.org
+exim4-config exim4/dc_other_hostnames string *.iankelling.org;iankelling.org;*iank.bid;iank.bid;*zroe.org;zroe.org;*.b8.nz;b8.nz
 
 
 
@@ -450,7 +535,10 @@ EOF
         # MAIN_HARDCODE_PRIMARY_HOSTNAME might mess up the
         # smarthost config type, not sure. all other settings
         # would be unused in that config type.
-        cat >$exim_main_dir/000_localmacros <<'EOF'
+        cat >$exim_main_dir/000_localmacros <<EOF
+# i don't have ipv6 setup for my tunnel yet.
+disable_ipv6 = true
+
 MAIN_TLS_ENABLE = true
 
 DKIM_CANON = relaxed
@@ -460,21 +548,25 @@ DKIM_SELECTOR = li
 # https://debian-administration.org/article/718/DKIM-signing_outgoing_mail_with_exim4
 
 # The file is based on the outgoing domain-name in the from-header.
-DKIM_DOMAIN = ${lc:${domain:$h_from:}}
+DKIM_DOMAIN = \${lc:\${domain:\$h_from:}}
 # sign if key exists
-DKIM_PRIVATE_KEY= ${if exists{/etc/exim4/${dkim_domain}-private.pem} {/etc/exim4/${dkim_domain}-private.pem}}
+DKIM_PRIVATE_KEY= \${if exists{/etc/exim4/\${dkim_domain}-private.pem} {/etc/exim4/\${dkim_domain}-private.pem}}
 
 
 # failing message on mail-tester.com:
 # We check if there is a server (A Record) behind your hostname treetowl.
 # You may want to publish a DNS record (A type) for the hostname treetowl or use a different hostname in your mail software
 # https://serverfault.com/questions/46545/how-do-i-change-exim4s-primary-hostname-on-a-debian-box
-# and this one seemed appropriate from grepping config
-MAIN_HARDCODE_PRIMARY_HOSTNAME = li.iankelling.org
+# and this one seemed appropriate from grepping config.
+# I originally set this to li.iankelling.org, but then ended up with errors when li tried to send
+# mail to treetowl, so this should basically be a name that no host has as their
+# canonical hostname since the actual host sits behind a nat and changes.
+# Seems logical for this to be the same as mailname.
+MAIN_HARDCODE_PRIMARY_HOSTNAME = mail.iankelling.org
 
 # normally empty, I set this so I can set the envelope address
 # when doing mail redelivery to invoke filters
-MAIN_TRUSTED_GROUPS = ian
+MAIN_TRUSTED_GROUPS = $u
 
 LOCAL_DELIVERY = dovecot_lmtp
 
@@ -491,6 +583,14 @@ CHECK_DATA_LOCAL_ACL_FILE = /etc/exim4/data_local_acl
 # the fix maybe is for all lines? one says gmail rejects, the
 # other says gmail does not reject. figure out and open a new bug.
 IGNORE_SMTP_LINE_LENGTH_LIMIT = true
+
+# most of the ones that gmail seems to use.
+# Exim has horrible default of signing unincluded
+# list- headers since they got mentioned in an
+# rfc, but this messes up mailing lists, like gnu/debian which want to
+# keep your dkim signature intact but add list- headers.
+DKIM_SIGN_HEADERS = mime-version:in-reply-to:references:from:date:subject:to
+
 EOF
 
 
@@ -519,12 +619,12 @@ EOF
 /^\s*mail_location\s*=/d
 EOF
 
-        cat >/etc/dovecot/conf.d/20-lmtp.conf <<'EOF'
+        cat >/etc/dovecot/conf.d/20-lmtp.conf <<EOF
 protocol lmtp {
 #per https://wiki2.dovecot.org/Pigeonhole/Sieve/Configuration
-  mail_plugins = $mail_plugins sieve
+  mail_plugins = \$mail_plugins sieve
 # default was
-  #mail_plugins = $mail_plugins
+  #mail_plugins = \$mail_plugins
 
 # For a normal setup with exim, we need something like this, which
 # removes the domain part
@@ -540,10 +640,10 @@ protocol lmtp {
 # A normal way to do this, which I did at first is to have
 # a router in exim almost at the end, eg 950,
 #local_catchall:
-#  debug_print = "R: catchall for $local_part@$domain"
+#  debug_print = "R: catchall for \$local_part@\$domain"
 #  driver = redirect
 #  domains = +local_domains
-#  data = ian
+#  data = $u
 # based on
 # http://blog.alteholz.eu/2015/04/exim4-and-catchall-email-address/
 # with superflous options removed.
@@ -551,7 +651,7 @@ protocol lmtp {
 # which makes filtering into mailboxes a little less robust or more complicated,
 # so I've done it this way instead. it also requires
 # modifying the local router in exim.
-  auth_username_format = ian
+  auth_username_format = $u
 }
 
 EOF
@@ -584,16 +684,16 @@ EOF
 
         systemctl enable offlineimapsync.timer
         systemctl start offlineimapsync.timer
-        systemctl restart openvpn-client@mail
-        systemctl enable openvpn-client@mail
+        systemctl restart $vpn_ser@mail
+        systemctl enable $vpn_ser@mail
         systemctl enable dovecot
         systemctl restart dovecot
 
     else # $HOSTNAME != $MAIL_HOST
         systemctl disable offlineimapsync.timer &>/dev/null ||:
         systemctl stop offlineimapsync.timer &>/dev/null ||:
-        systemctl disable openvpn-client@mail
-        systemctl stop openvpn-client@mail
+        systemctl disable $vpn_ser@mail
+        systemctl stop $vpn_ser@mail
         systemctl disable dovecot ||:
         systemctl stop dovecot ||:
         #
@@ -604,6 +704,9 @@ EOF
         debconf-set-selections <<EOF
 exim4-config exim4/dc_eximconfig_configtype select mail sent by smarthost; no local mail
 exim4-config exim4/dc_smarthost string $smarthost
+# the default, i think is from /etc/mailname. better to set it to
+# whatever the current fqdn is.
+exim4-config exim4/mailname string $(hostname -f)
 EOF
 
     fi # end $HOSTNAME != $MAIL_HOST
@@ -615,6 +718,25 @@ EOF
         rm -f /etc/exim4/update-exim4.conf.conf
         dpkg-reconfigure -u -fnoninteractive exim4-config
     fi
+
+    # i have the spool directory be common to distro multi-boot, so
+    # we need the uid to be the same. 608 cuz it's kind of in the middle
+    # of the free system uids.
+    IFS=:; read _ _ uid _ < <(getent passwd Debian-exim ); unset IFS
+    IFS=:; read _ _ gid _ < <(getent group Debian-exim ); unset IFS
+    if [[ ! $uid ]]; then
+        # from /var/lib/dpkg/info/exim4-base.postinst, plus uid and gid options
+       adduser --uid 608 --gid 608 --system --group --quiet --home /var/spool/exim4 \
+               --no-create-home --disabled-login --force-badname Debian-exim
+    elif [[ $uid != 608 ]]; then
+        systemctl stop exim4 ||:
+        usermod -u 608 Debian-exim
+        groupmod -g 608 Debian-exim
+        usermod -g 608 Debian-exim
+        find / /nocow -xdev -uid $uid -exec chown -h 608 {} +
+        find / /nocow -xdev -gid $gid -exec chgrp -h 608 {} +
+    fi
+
     # light version of exim does not have sasl auth support.
     apt-get -y install --purge --auto-remove exim4-daemon-heavy spamassassin
 
@@ -641,7 +763,7 @@ Type=oneshot
 ExecStart=/a/bin/distro-setup/spamd-dns-fix
 EOF
     # 2017-09, debian closed the bug on this saying upstream had fixed it.
-    # remove this when i'm using the newer package, ie, debian 10, or maybe
+    # remove this when i\'m using the newer package, ie, debian 10, or maybe
     # ubuntu 18.04.
     cat >/etc/systemd/system/spamddnsfix.timer <<'EOF'
 [Unit]
@@ -664,53 +786,6 @@ EOF
     #####   end spamassassin config
 
 
-    f=/usr/local/bin/mail-cert-cron
-    cat >$f <<'EOF'
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
-
-[[ $EUID == 0 ]] || exec sudo "$BASH_SOURCE" "$@"
-
-f=/a/bin/bash_unpublished/source-semi-priv
-if [[ -e $f ]]; then
-    source $f
-fi
-if [[ $HOSTNAME == $MAIL_HOST ]]; then
-    local_mx=mail.iankelling.org
-    rsync_common="rsync -ogtL --chown=root:Debian-exim --chmod=640 root@li:/etc/letsencrypt/live/$local_mx/"
-    ${rsync_common}fullchain.pem /etc/exim4/exim.crt
-    ${rsync_common}privkey.pem /etc/exim4/exim.key
-fi
-EOF
-    chmod 755 $f
-
-    cat >/etc/systemd/system/mailcert.service <<'EOF'
-[Unit]
-Description=Mail cert rsync
-After=multi-user.target
-
-[Service]
-Type=oneshot
-ExecStart=/a/bin/log-quiet/sysd-mail-once mailcert /usr/local/bin/mail-cert-cron
-EOF
-
-    cat >/etc/systemd/system/mailcert.timer <<'EOF'
-[Unit]
-Description=Run mail-cert once a day
-
-[Timer]
-OnCalendar=daily
-
-[Install]
-WantedBy=timers.target
-EOF
-    systemctl daemon-reload
-    systemctl start mailcert
-    systemctl restart mailcert.timer
-    systemctl enable mailcert.timer
-
-
-
 
 
 
@@ -783,6 +858,28 @@ dovecot_lmtp:
         batch_max = 200
 EOF
 
+    cat >/etc/exim4/conf.d/router/190_exim4-config_fsfsmarthost <<'EOF'
+# smarthost for fsf mail
+# ian: copied from /etc/exim4/conf.d/router/200_exim4-config_primary, and added senders = and
+# replaced DCsmarthost with mail.fsf.org
+fsfsmarthost:
+  debug_print = "R: smarthost for $local_part@$domain"
+  driver = manualroute
+  domains = ! +local_domains
+  senders = *@fsf.org
+  transport = remote_smtp_smarthost
+  route_list = * mail.fsf.org byname
+  host_find_failed = ignore
+  same_domain_copy_routing = yes
+  no_more
+EOF
+
+    # https://blog.dhampir.no/content/make-exim4-on-debian-respect-forward-and-etcaliases-when-using-a-smarthost
+    # i only need .forwards, so just doing that one.
+    cd /etc/exim4/conf.d/router
+    b=userforward_higher_priority
+    # replace the router name so it is unique
+    sed -r s/^\\S+:/$b:/ 600_exim4-config_userforward >175_$b
 
     # begin setup passwd.client
     f=/etc/exim4/passwd.client
@@ -794,21 +891,15 @@ EOF
     done
     # end setup passwd.client
 
-    # https://blog.dhampir.no/content/make-exim4-on-debian-respect-forward-and-etcaliases-when-using-a-smarthost
-    # i only need .forwards, so just doing that one.
-    cd /etc/exim4/conf.d/router
-    b=userforward_higher_priority
-    # replace the router name so it is unique
-    sed -r s/^\\S+:/$b:/ 600_exim4-config_userforward >175_$b
     systemctl restart exim4
 
-fi  # end if exim4
+fi  #### end if exim4
 
 # /etc/alias setup is debian specific, and
 # exim config sets up an /etc/alias from root to the postmaster, which i
 # config to ian, as long as there exists an entry for root, or there was
 # no preexisting aliases file. based on the postinst file. postfix
-# won't set up a root to $postmaster alias if it's already installed.
+# won\'t set up a root to $postmaster alias if it\'s already installed.
 # Since postfix is not the greatest, just set it ourselves.
 if [[ $postmaster != root ]]; then
     sed -i --follow-symlinks -f - /etc/aliases <<EOF
@@ -821,12 +912,12 @@ fi
 # put spool dir in directory that spans multiple distros.
 # based on http://www.postfix.org/qmgr.8.html and my notes in gnus
 #
-# todo: I'm suspicious of uids for Debian-exim being the same across
+# todo: I\'m suspicious of uids for Debian-exim being the same across
 # distros. It would be good to test this.
 dir=/nocow/$type
 sdir=/var/spool/$type
 # we only do this if our system has $dir
-if [[ -e $dir && $(readlink -f $sdir) != $dir ]]; then
+if [[ -e /nocow && $(readlink -f $sdir) != $dir ]]; then
     systemctl stop $type
     if [[ ! -e $dir && -d $sdir ]]; then
         mv $sdir $dir
@@ -844,11 +935,19 @@ if dpkg -s radicale &>/dev/null; then
     if [[ $HOSTNAME == $MAIL_HOST ]]; then
         systemctl restart radicale
         systemctl enable radicale
+        if [[ -e /etc/logrotate.d/radicale.disabled ]]; then
+            mv /etc/logrotate.d/radicale{.disabled,}
+        fi
     else
         systemctl stop radicale
         systemctl disable radicale
+        # weekly logrotate tries to restart radicale even if it's a disabled service in flidas.
+        if [[ -e /etc/logrotate.d/radicale ]]; then
+            mv /etc/logrotate.d/radicale{,.disabled}
+        fi
     fi
 fi
+exit 0
 
 # if I wanted the from address to be renamed and sent to a different address,
 # echo "sdx@localhost development@localhost" | sudo dd of=/etc/postfix/recipient_canonical